package hu.bme.mit.bookmanager;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class BookManager {

	private List<Book> bookList = new ArrayList<Book>();
	
	public static BookManager initialize() {
		BookManager manager = new BookManager();
		manager.addBook(new Book(
				"Terry Pratchett", "The Light Fantastic",
				512, false));
		manager.addBook(new Book("Neil Gaiman", "Anansi Boys", 525, true));
		manager.addBook(new Book("Terry Pratchett", "The Color of Magic",
				 300, false));
		manager.addBook(new Book("Neil Gaiman", "American Gods", 
				700, true));
		manager.addBook(new Book("Steven Erikson", "Memories of Ice", 1200, false));
		manager.addBook(new Book("Steven Erikson", "Deadhouse Gates", 900, true));
		return manager;
	}
	
	public void addBook(Book book) {
		bookList.add(book);
	}
	
	public void removeBook(Book book) {
		bookList.remove(book);
	}
	
	public List<Book> getAllBooks() {
		return Collections.unmodifiableList(bookList);
	}
	
	public List<Book> getAllBooksOfAuthor(String author) {
		if (author == null) {
			throw new IllegalArgumentException("Author name cannot be null");
		}
		List<Book> filteredList = new ArrayList<Book>();
		for (Book book : bookList) {
			if (author.equals(book.getAuthor())) {
				filteredList.add(book);
			}
		}
		return filteredList;
	}
}
